"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const T = __importStar(require("fp-ts/lib/Task"));
const rxjs_1 = require("rxjs");
const O = __importStar(require("fp-ts/lib/Option"));
const pipeable_1 = require("fp-ts/lib/pipeable");
const Rx = __importStar(require("rxjs/operators"));
exports.URI = 'effe-ts/Cmd';
exports.none = rxjs_1.EMPTY;
exports.constNone = () => exports.none;
exports.of = (a) => rxjs_1.of(T.of(O.some(a)));
function getMonoid() {
    return {
        concat: (x, y) => rxjs_1.merge(x, y),
        empty: exports.none
    };
}
exports.getMonoid = getMonoid;
function perform(task, f) {
    return rxjs_1.of(pipeable_1.pipe(task, T.map(a => O.some(f(a)))));
}
exports.perform = perform;
function perform_(task) {
    return rxjs_1.of(pipeable_1.pipe(task, T.map(() => O.none)));
}
exports.perform_ = perform_;
function attempt(task, f) {
    return perform(task, f);
}
exports.attempt = attempt;
exports.cmd = {
    URI: exports.URI,
    map: (ma, f) => pipeable_1.pipe(ma, Rx.map(T.map(O.map(f)))),
    of: exports.of,
    ap: (mab, ma) => pipeable_1.pipe(rxjs_1.combineLatest(mab, ma), Rx.map(([mab, ma]) => () => Promise.all([mab(), ma()]).then(([mab, ma]) => O.option.ap(mab, ma)))),
    chain: (ma, f) => pipeable_1.pipe(ma, Rx.mergeMap(rxjs_1.defer), Rx.mergeMap(O.fold(() => rxjs_1.EMPTY, f)))
};
const { ap, apFirst, apSecond, chain, chainFirst, flatten, map } = pipeable_1.pipeable(exports.cmd);
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.flatten = flatten;
exports.map = map;
//# sourceMappingURL=Cmd.js.map