"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rr = __importStar(require("fp-ts/lib/Reader"));
const pipeable_1 = require("fp-ts/lib/pipeable");
const RX = __importStar(require("fp-ts-rxjs/lib/Observable"));
const Apply_1 = require("fp-ts/lib/Apply");
exports.URI = 'effe-ts/Sub';
function fromObservable(actions$) {
    return Rr.of(actions$);
}
exports.fromObservable = fromObservable;
function fromCmd(cmd) {
    return Rr.of(pipeable_1.pipe(cmd, RX.chain(RX.fromTask), RX.chain(RX.fromOption)));
}
exports.fromCmd = fromCmd;
const monoidObservable = RX.getMonoid();
exports.none = fromObservable(monoidObservable.empty);
function getMonoid() {
    const monoidObservable = RX.getMonoid();
    return {
        concat: (x, y) => model$ => monoidObservable.concat(x(model$), y(model$)),
        empty: exports.none
    };
}
exports.getMonoid = getMonoid;
exports.sub = {
    URI: exports.URI,
    map: (ma, f) => model$ => RX.map(f)(ma(model$)),
    promap: (fbc, f, g) => model$ => pipeable_1.pipe(model$, RX.map(f), fbc, RX.map(g)),
    ap: (mab, ma) => model$ => pipeable_1.pipe(Apply_1.sequenceT(RX.observable)(mab(model$), ma(model$)), RX.map(([f, a]) => f(a))),
    of: a => Rr.of(RX.of(a)),
    chain: (ma, f) => model$ => pipeable_1.pipe(ma(model$), RX.chain(a => f(a)(model$)))
};
const { ap, apFirst, apSecond, chain, map, chainFirst, flatten, promap } = pipeable_1.pipeable(exports.sub);
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.map = map;
exports.chainFirst = chainFirst;
exports.flatten = flatten;
exports.promap = promap;
//# sourceMappingURL=Sub.js.map