"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rr = __importStar(require("fp-ts/lib/Reader"));
const pipeable_1 = require("fp-ts/lib/pipeable");
const sub = __importStar(require("./Sub"));
exports.URI = 'effe-ts/SubR';
exports.none = Rr.of(sub.none);
function fromObservable(actions$) {
    return Rr.of(sub.fromObservable(actions$));
}
exports.fromObservable = fromObservable;
function fromSub(sub) {
    return Rr.of(sub);
}
exports.fromSub = fromSub;
function fromCmd(cmd) {
    return fromSub(sub.fromCmd(cmd));
}
exports.fromCmd = fromCmd;
function fromCmdR(cmdr) {
    return r => sub.fromCmd(cmdr(r));
}
exports.fromCmdR = fromCmdR;
function getMonoid() {
    return Rr.getMonoid(sub.getMonoid());
}
exports.getMonoid = getMonoid;
exports.subr = {
    URI: exports.URI,
    map: (ma, f) => r => sub.sub.map(ma(r), f),
    promap: (fbc, f, g) => r => sub.sub.promap(fbc(r), f, g),
    ap: (mab, ma) => r => sub.sub.ap(mab(r), ma(r)),
    of: a => Rr.of(sub.sub.of(a)),
    chain: (ma, f) => r => sub.sub.chain(ma(r), a => f(a)(r))
};
const { ap, apFirst, apSecond, chain, map, chainFirst, flatten, promap } = pipeable_1.pipeable(exports.subr);
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.map = map;
exports.chainFirst = chainFirst;
exports.flatten = flatten;
exports.promap = promap;
//# sourceMappingURL=SubR.js.map