"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const pipeable_1 = require("fp-ts/lib/pipeable");
const Rr = __importStar(require("fp-ts/lib/Reader"));
const cmd = __importStar(require("./Cmd"));
exports.URI = 'effe-ts/CmdR';
exports.ask = () => cmd.of;
exports.asks = (f) => r => cmd.of(f(r));
exports.env = (f) => r => f(r)(r);
exports.none = Rr.of(rxjs_1.EMPTY);
exports.of = (a) => Rr.of(cmd.of(a));
function getMonoid() {
    return Rr.getMonoid(cmd.getMonoid());
}
exports.getMonoid = getMonoid;
function perform(task, f) {
    return r => cmd.perform(task(r), f);
}
exports.perform = perform;
function perform_(task) {
    return r => cmd.perform_(task(r));
}
exports.perform_ = perform_;
function attempt(task, f) {
    return perform(task, f);
}
exports.attempt = attempt;
function fromCmd(cmd) {
    return () => cmd;
}
exports.fromCmd = fromCmd;
exports.cmdr = {
    URI: exports.URI,
    map: (ma, f) => r => cmd.cmd.map(ma(r), f),
    of: exports.of,
    ap: (mab, ma) => r => cmd.cmd.ap(mab(r), ma(r)),
    chain: (ma, f) => r => cmd.cmd.chain(ma(r), a => f(a)(r))
};
const { ap, apFirst, apSecond, chain, chainFirst, flatten, map } = pipeable_1.pipeable(exports.cmdr);
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.flatten = flatten;
exports.map = map;
//# sourceMappingURL=CmdR.js.map